/** \file ps_macro.h
 * Some macros used by the particle systems for rendering.
 *
 * $Id: ps_macro.h,v 1.5 2004/03/19 10:11:35 corvazier Exp $
 */

/* Copyright, 2000, 2001 Nevrax Ltd.
 *
 * This file is part of NEVRAX NEL.
 * NEVRAX NEL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.

 * NEVRAX NEL is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with NEVRAX NEL; see the file COPYING. If not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */


/// NOTE: for private use, do not include this

#ifndef NL_PS_MACRO_H
#define NL_PS_MACRO_H

#include "nel/misc/types_nl.h"

/// this macro is used to see whether a write in a vertex buffer is correct
#ifdef NL_DEBUG
	#define CHECK_VERTEX_BUFFER(vb, pt) { CVertexBufferRead vba; (vb).lock (vba); \
										nlassert((uint8 *) (pt) >= (uint8 *) vba.getVertexCoordPointer()  \
				&& (uint8 *) (pt) < ((uint8 *) vba.getVertexCoordPointer() + (vb).getVertexSize() * (vb).getNumVertices()));}
#else
	#define CHECK_VERTEX_BUFFER(a,b)
#endif

// private usage : macro to check the memory integrity
#if defined(NL_DEBUG) && defined(NL_OS_WINDOWS)
	// #define PARTICLES_CHECK_MEM NLMEMORY::CheckHeap(true);
	#define PARTICLES_CHECK_MEM 
#else
	#define PARTICLES_CHECK_MEM
#endif

#endif
